/*
   ┏━━━┓╱╱╱╱╱┏┓╱╱┏┓╱╱╱╱╱┏┓╱╱
   ┃┏━┓┃╱╱╱╱╱┃┃╱╱┃┃╱╱╱╱╱┃┃╱╱╱
   ┃┗━┛┣┓┏┳━━┫┃┏┓┃┃╱╱┏━━┫┗━┳━━┓
   ┃┏━━┫┃┃┃┏┓┃┗┛┃┃┃╱┏┫┏┓┃┏┓┃━━┫
   ┃┃╱╱┃┗┛┃┃┃┃┏┓┃┃┗━┛┃┏┓┃┗┛┣━━┃
   ┗┛╱╱┗━━┻┛┗┻┛┗┛┗━━━┻┛┗┻━━┻━━┛
    ━━━━━━━━━━━━━━━━━━━━━━━━━━

    Copyright (c) 2024 Punk Labs LLC

    This section is part of OneTrick B-BOI

    OneTrick B-BOI is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by the Free
    Software Foundation, either version 3 of the License, or (at your option)
    any later version.

    OneTrick B-BOI is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
    more details.

    You should have received a copy of the GNU General Public License along with
    OneTrick B-BOI.  If not, see <http://www.gnu.org/licenses/>.
*/

#![allow(warnings)]
#![allow(approx_constant)]

/*
#![allow(unused_parens)]
#![allow(non_snake_case)]
#![allow(non_camel_case_types)]
#![allow(dead_code)]
#![allow(unused_variables)]
#![allow(unused_mut)]
#![allow(non_upper_case_globals)]
#![allow(clippy::double_parens)]
#![allow(clippy::needless_return)]
#![allow(clippy::excessive_precision)]
#![allow(clippy::unnecessary_cast)]
#![allow(clippy::manual_clamp)]
#![allow(clippy::collapsible_else_if)]
*/

pub mod modules {
    pub mod output {
        // include!("generated/dsp_output.rs");
        use onetrick::prelude::*;
        include_dsp!("generated/dsp_output.rs");
    }
    pub use output::DSP_Output;
    pub mod sampler {
        // include!("generated/dsp_sampler.rs");
        use onetrick::prelude::*;
        include_dsp!("generated/dsp_sampler.rs");
    }
    pub use sampler::DSP_Sampler;
    pub mod voice_changer {
        use onetrick::prelude::*;
        include_dsp!("generated/dsp_voicechanger.rs");
    }
    pub use voice_changer::DSP_VoiceChanger;
}
