/*
   ┏━━━┓╱╱╱╱╱┏┓╱╱┏┓╱╱╱╱╱┏┓╱╱
   ┃┏━┓┃╱╱╱╱╱┃┃╱╱┃┃╱╱╱╱╱┃┃╱╱╱
   ┃┗━┛┣┓┏┳━━┫┃┏┓┃┃╱╱┏━━┫┗━┳━━┓
   ┃┏━━┫┃┃┃┏┓┃┗┛┃┃┃╱┏┫┏┓┃┏┓┃━━┫
   ┃┃╱╱┃┗┛┃┃┃┃┏┓┃┃┗━┛┃┏┓┃┗┛┣━━┃
   ┗┛╱╱┗━━┻┛┗┻┛┗┛┗━━━┻┛┗┻━━┻━━┛
    ━━━━━━━━━━━━━━━━━━━━━━━━━━

    Copyright (c) 2024 Punk Labs LLC

    This section is part of OneTrick B-BOI

    OneTrick B-BOI is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by the Free
    Software Foundation, either version 3 of the License, or (at your option)
    any later version.

    OneTrick B-BOI is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
    more details.

    You should have received a copy of the GNU General Public License along with
    OneTrick B-BOI.  If not, see <http://www.gnu.org/licenses/>.
*/

declare name "OneTrick B-BOI DSP";
declare copyright "Copyright (c) 2023 Punk Labs LLC";
declare license "GPLv3 (or later)";

import("onetrick.lib");
import("params.lib");


addMixSaturation = ot.saturationUrchin(mixSaturation * 0.75); // Tone it down a bit...
// mediaHighpassAdjusted = ot.interpolate_freq(ot.input.modWheel : ot.smoothParam, mediaHighpass, 880);
// mediaLowpassAdjusted = ot.interpolate_freq(ot.input.modWheel : ot.smoothParam, mediaLowpass, 1760);
addMediaFilters = fi.highpass(2, mediaHighpass) : fi.lowpass(4, mediaLowpass);
mediaNoise = ot.interpolate_linear_stereo(mediaNoiseType, ot.stereoVinylNoise, ot.stereoTapeNoise) : ot.stereo(*(mediaNoiseAmount));
addMediaNoise = ot.addStereoNoiseGated(mediaNoise, -20+5, -80, ot.input.hold);

addMediaFlutter = ot.flutterStereo(mediaSpeed/60, mediaShape, mediaFlutter);
addMonoEffect = ot.monoizeBlend(mediaMono) : ot.stereo(*(1+mediaMono*0.25)); // Compensate some for loss of volume

samplerSamplerateAdjusted = ot.interpolate_freq(ot.input.modWheel, samplerSamplerate, 1000);
samplerBitsAdjusted = it.interpolate_linear(ot.input.modWheel, samplerBits, 4);
addSamplerBitcrusher = ot.bitcrusher(samplerBitsAdjusted, samplerSamplerateAdjusted);


process(left, right) =
    (left, right)
    : addMediaNoise
    : ot.stereo(
        addMediaFilters
        : addSamplerBitcrusher
        : addMixSaturation
        : *(mixGain)
    )
    : ot.limiter_stereo;