/*
   ┏━━━┓╱╱╱╱╱┏┓╱╱┏┓╱╱╱╱╱┏┓╱╱   
   ┃┏━┓┃╱╱╱╱╱┃┃╱╱┃┃╱╱╱╱╱┃┃╱╱╱  
   ┃┗━┛┣┓┏┳━━┫┃┏┓┃┃╱╱┏━━┫┗━┳━━┓
   ┃┏━━┫┃┃┃┏┓┃┗┛┃┃┃╱┏┫┏┓┃┏┓┃━━┫
   ┃┃╱╱┃┗┛┃┃┃┃┏┓┃┃┗━┛┃┏┓┃┗┛┣━━┃
   ┗┛╱╱┗━━┻┛┗┻┛┗┛┗━━━┻┛┗┻━━┻━━┛
    ━━━━━━━━━━━━━━━━━━━━━━━━━━ 

    Copyright (c) 2024 Punk Labs LLC

    This file is part of OneTrick B-BOI

    OneTrick B-BOI is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by the Free
    Software Foundation, either version 3 of the License, or (at your option)
    any later version.

    OneTrick B-BOI is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
    more details.

    You should have received a copy of the GNU General Public License along with
    OneTrick B-BOI.  If not, see <http://www.gnu.org/licenses/>.
*/

declare name "OneTrick B-BOI DSP";
declare copyright "Copyright (c) 2024 Punk Labs LLC";
declare license "GPLv3 (or later)";

import("shared.lib");

samplerRunning = ot.triggerAndStop(ot.input.trigger, ot.input.sampleIndexChanged);
sampleTime = ot.timer.whileHeldTuned(samplerRunning, ot.input.key + (voiceTranspose + ot.input.pitchShift(12) : ot.smoothParam));

sampleVolume = ot.input.velocity * ba.db2linear(-6);
voice = ot.sample(ot.input.sampleIndex).oneShot.cubic(sampleTime).channel(0)
    : ot.filterTriggerClicks(ot.input.trigger)
    : *(sampleVolume);
    
process = voice : processVoice;
